summaryrefslogtreecommitdiffstats
path: root/libraries
diff options
context:
space:
mode:
author David O'Shaughnessy2020-01-03 22:05:20 +0100
committer Willy Sudiarto Raharjo2020-01-12 02:47:58 +0100
commitbd5476c7609004e3f6213982d9f1c3041aa76c20 (patch)
tree5e0677f6d889ea1650d717862c4d3860eb340191 /libraries
parentafeec61f7f13fc92c1362fc55e83244ea46a6609 (diff)
downloadslackbuilds-bd5476c7609004e3f6213982d9f1c3041aa76c20.tar.gz
libraries/olm: Added (olm and megolm cryptographic ratchets)
Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
Diffstat (limited to 'libraries')
-rw-r--r--libraries/olm/README18
-rw-r--r--libraries/olm/olm.SlackBuild101
-rw-r--r--libraries/olm/olm.info10
-rw-r--r--libraries/olm/slack-desc19
4 files changed, 148 insertions, 0 deletions
diff --git a/libraries/olm/README b/libraries/olm/README
new file mode 100644
index 0000000000..fcdee97450
--- /dev/null
+++ b/libraries/olm/README
@@ -0,0 +1,18 @@
+olm (olm and megolm cryptographic ratchets)
+
+An implementation of the Double Ratchet cryptographic ratchet described by
+https://whispersystems.org/docs/specifications/doubleratchet/, written in
+C and C++11 and exposed as a C API.
+
+The specification of the Olm ratchet can be found in olm.md.
+
+This library also includes an implementation of the Megolm cryptographic
+ratchet, as specified in megolm.md.
+
+Olm is designed to be easy port to different platforms and to be easy to
+write bindings for.
+
+It was originally implemented in C++, with a plain-C layer providing the
+public API. As development has progressed, it has become clear that C++
+gives little advantage, and new functionality is being added in C, with
+C++ parts being rewritten as the need arises.
diff --git a/libraries/olm/olm.SlackBuild b/libraries/olm/olm.SlackBuild
new file mode 100644
index 0000000000..89ed8ad2fc
--- /dev/null
+++ b/libraries/olm/olm.SlackBuild
@@ -0,0 +1,101 @@
+#!/bin/sh
+
+# Slackware build script for olm
+
+# Copyright 2020 David O'Shaughnessy
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=olm
+VERSION=${VERSION:-3.1.4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar jxvf $CWD/$PRGNAM-$VERSION.tar.bz2
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cmake . \
+ -Bbuild \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+ -DCMAKE_BUILD_TYPE=Release
+cmake --build build
+cd build/tests
+ctest .
+cd ..
+make install DESTDIR=$PKG
+cd ..
+
+# Strip binaries and libraries
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ docs/* \
+ README.md LICENSE CHANGELOG.rst CONTRIBUTING.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/olm/olm.info b/libraries/olm/olm.info
new file mode 100644
index 0000000000..8faa32cb87
--- /dev/null
+++ b/libraries/olm/olm.info
@@ -0,0 +1,10 @@
+PRGNAM="olm"
+VERSION="3.1.4"
+HOMEPAGE="https://gitlab.matrix.org/matrix-org/olm"
+DOWNLOAD="https://gitlab.matrix.org/matrix-org/olm/-/archive/3.1.4/olm-3.1.4.tar.bz2"
+MD5SUM="c45da62ae90274157576ff405c8057c9"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="David O'Shaughnessy"
+EMAIL="dev@osh.id.au"
diff --git a/libraries/olm/slack-desc b/libraries/olm/slack-desc
new file mode 100644
index 0000000000..0a14035970
--- /dev/null
+++ b/libraries/olm/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+olm: olm (Implementation of the olm and megolm cryptographic ratchets)
+olm:
+olm: An implementation of the Double Ratchet cryptographic ratchet
+olm: described by:
+olm: https://whispersystems.org/docs/specifications/doubleratchet/
+olm: written in C and C++11 and exposed as a C API.
+olm:
+olm: The specification of the Olm ratchet can be found in olm.md.
+olm:
+olm: This library also includes an implementation of the Megolm
+olm: cryptographic ratchet, as specified in megolm.md.